diff --git a/Makefile b/Makefile
index 2545f9b..2f224c5 100644
--- a/Makefile
+++ b/Makefile
@@ -34,11 +34,11 @@ ifneq (,$(findstring unix,$(platform)))
 
 # use for raspberry pi
 else ifeq ($(platform), rpi)
-	   TARGET := $(TARGET_NAME)_libretro.so
-	   fpic := -fPIC
-		 LDFLAGS := -lpthread
-		 PLATFLAGS +=  -DARM  -marm
-	   SHARED := -shared -Wl,--version-script=$(CORE_DIR)/libretro/link.T
+	TARGET := $(TARGET_NAME)_libretro.so
+	fpic := -fPIC
+	LDFLAGS := -lpthread -lm -ldl
+	PLATFLAGS +=  -DARM  -marm
+	SHARED := -shared -Wl,--version-script=$(CORE_DIR)/libretro/link.T -Wl,--as-needed -Wl,--no-undefined
 
 # Classic Platforms ####################
 # Platform affix = classic_<ISA>_<µARCH>
diff --git a/sources/src/filesys_linux.c b/sources/src/filesys_linux.c
index 10a8cf4..7b0d6d3 100644
--- a/sources/src/filesys_linux.c
+++ b/sources/src/filesys_linux.c
@@ -18,14 +18,7 @@
 #endif
 
 #ifndef _WIN32
-struct timeb {
-    time_t          time;
-    unsigned short  millitm;
-    short           timezone;
-    short           dstflag;
-};
-
-extern int ftime(struct timeb*  timebuf);
+#include <sys/timeb.h>
 #endif
 
 typedef int BOOL;
